/*
 *	htanaly.cpp
 */

/*	Copyright (C) 1999 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htstring.h"
#include "htanaly.h"
#include "htidle.h"

hts_analy::hts_analy(htfile *file, analyser *A, ADDR Lowestaddress, ADDR Highestaddress, ADDR Entrypointaddress)
:hts_sub(file)
{
	analy = A;
     register_idle_object(this);
     lowestaddress=Lowestaddress;
     highestaddress=Highestaddress;
     entrypointaddress=Entrypointaddress;
}

hts_analy::~hts_analy()
{
	unregister_idle_object(this);
}

void hts_analy::end_line_address(dword *ofs, int *yofs)
{
	*ofs=highestaddress;
	*yofs=0;
}

int hts_analy::getline(char *line, dword ofs, int yofs)
{
	int len;
     analy->getformattedline(ofs, yofs+1, line, &len);
	return 1;
}

void	hts_analy::idle()
{
	analy->continueanalysis();
}

int	hts_analy::next_line_address(ADDR *ofs, int *yofs, int n)
{
    	int len;
     char buf[100];
     int res=0;
     while (n--) {
		if (analy->getformattedline(*ofs, *yofs+2, buf, &len)) {
     		(*yofs)++;
     	} else {
          	analy->getformattedline(*ofs, *yofs+1, buf, &len);
//     		if (!analy->validaddr(*ofs+len, scvalid)) return res;
     		*yofs = 0;
          	*ofs += len;
     	}
          res++;
     }
	return res;
}

#define LOOP_BACK 128
int	hts_analy::prev_line_address(ADDR *addr, int *line, int n)
{
	int len;
     char buf[512];

     ADDR addrbuf[1024];
     int	linebuf[1024];
     int	i=0;

     /* look backwards */
   	ADDR tmpaddr = (*addr) - LOOP_BACK;
     ADDR tmpaddr2;
     int	tmpline;
     start_line_address(&tmpaddr2, &tmpline);
	if ((LOOP_BACK > (*addr)) || (tmpaddr < tmpaddr2)) tmpaddr = tmpaddr2;
    	ADDR	nextaddr = tmpaddr;
     while (1) {
          if (tmpaddr >= (*addr)) {
          	if (tmpline >= (*line)) break;
          }
	     if (analy->getformattedline(tmpaddr, tmpline+1, buf, &len)) {
          	nextaddr += len;
               tmpline++;
          } else {
               tmpaddr = nextaddr;
               tmpline = 0;
               continue;
          }
     	addrbuf[i] = tmpaddr;
          linebuf[i] = tmpline-1;
          i++;
     }

     if (!i) return 0;

     if (i >= n) {
	     (*addr) = addrbuf[i-n];
	     (*line) = linebuf[i-n];
          return n;
     } else {
     	(*addr) = addrbuf[0];
     	(*line) = linebuf[0];
          return i;
     }
}

void	hts_analy::start_line_address(dword *ofs, int *yofs)
{
	*ofs=lowestaddress;
//	*ofs=entrypointaddress;
     *yofs=0;
}

int hts_analy::jump(ADDR tofs, ADDR *ofs, int *yofs)
{
	if (analy->validaddr(tofs, scvalid)) {
     	*ofs=tofs;
          *yofs=0;
          return 1;
     }
     return 0;
}


