#ifndef __HTAPP_H__
#define __HTAPP_H__

#include "htdialog.h"
#include "htobj.h"

/*
 *	CLASS ht_menu
 */

class ht_menu: public ht_view {
public:
	ht_menu(bounds *b);
     ~ht_menu();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
};

/*
 *	CLASS ht_keyline
 */

class ht_keyline: public ht_view {
public:
	ht_keyline(bounds *b);
     ~ht_keyline();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
};

/*
 *	CLASS ht_app
 */

class ht_app: public ht_group {
private:
     ht_logviewer *logviewer;
     ht_menu *menu;
     ht_keyline *keyline;

     int h0;

	ht_window *findwindowbynumber(int index);
     int findfreewinnumber();
public:
	ht_app(bounds *b);
	~ht_app();
/* overwritten */
	virtual void draw();
	virtual void handlemsg(htmsg *msg);
/* new */
	int new_window(char *filename);
     void delete_window(int index);
     void focus_window(int index);
     int logf(const char *format, ...);

     void windowlist_popup();

     void view_manager_popup();
     void view_manager_dump(ht_view *view, ht_listbox *listbox, ht_collection *structure, int depth, int *currenti, ht_view *currentv);
};

#define LOG(a...) app->logf(a);

extern ht_app *app;
extern screendrawbuf *screen;

int htapp_init();
void htapp_done();

#endif /* __HTAPP_H__ */
