#ifndef __HTDEBUG_H__
#define __HTDEBUG_H__

#include <stdio.h>

/****************************************************************************/
#define HTDEBUG
/****************************************************************************/

void ht_assert_failed(char *file, int line, char *assertion);
void ht_warn(char *file, int line, char *format,...);
void ht_error(char *file, int line, char *format,...);

int new_timer();
void start_timer(int handle);
void stop_timer(int handle);
void delete_timer(int h);

long long int get_timer_sec(int handle);
long long int get_timer_msec(int handle);
long long int get_timer_tick(int handle);

#define WARN(a...) ht_warn(__FILE__, __LINE__, a)
#define ERROR(a...) ht_error(__FILE__, __LINE__, a)

#ifdef HTDEBUG
	#define assert(a) if (!(a)) ht_assert_failed(__FILE__, __LINE__, (#a));
#else
	#define assert(a) ((void)0)
#endif

#define abstract() ERROR("abstract method called\n")

#define ABSTRACT
#define STUB

#endif /* !__HTDEBUG_H__ */
