/* 
 *	The HTE Editor
 *	htmzrel.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzrel.h"
#include "htlayout.h"
#include "htstring.h"
#include "viewers.h"

int htmzrel_detect(htfile *file)
{
	word rcount;
     file->seek(6);
     file->read(&rcount, 2);
	return rcount;
}

ht_view *htmzrel_init(bounds *b, htfile *file, ht_group *group)
{
	ht_uviewer *v=new ht_uviewer(b, "mz/relocations", file);
     ADDR r=0;
     dword rc=0;
    	file->seek(6);
	file->read(&rc, 2);
    	file->seek(24);
	file->read(&r, 2);
     char buf[256];
	hts_mask *m=new hts_mask(file, 0);
	m->add_mask("MZ relocations (additive using CS)");
     for (int i=rc; i>0; i--) {
     	int so;
     	file->seek(r);
          file->read(&so, 4);
	     sprintf(buf, HT_EDIT_WORD_FORMAT":"HT_EDIT_WORD_FORMAT, r+2, 0, htc_edit_normal, r, 0, htc_edit_normal);
		m->add_mask(buf);
          r+=4;
	}
	v->insertsub(m);
     return v;
}

viewer_int htmzrel_int = {
	htmzrel_detect,
	htmzrel_init
};
