/* 
 *	The HTE Editor
 *	htpeimg.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htnewexe.h"
#include "htpeimg.h"
#include "htstring.h"
#include "viewers.h"

#include "pestruct.h"

#include "htanaly.h"
#include "pe_analy.h"

int htpeimage_detect(htfile *file)
{
	return 1;
}

ht_view *htpeimage_init(bounds *b, htfile *file, ht_group *group)
{
	LOG("PE: image");
	ht_uviewer *v=new ht_uviewer(b, "pe/image", file);

     ht_pe_shared_data *pe_shared=(ht_pe_shared_data*)group->shared_data;

     pe_analyser *p = new pe_analyser();
     p->init(pe_shared, file);
     p->beginanalysis(pe_shared->pe32header.entrypoint_address+pe_shared->pe32header.image_base);
/* lowest/highest finden */
     ADDR l=(ADDR)-1, h=0;
     PE_SECTION_HEADER *s=pe_shared->sections.sections;
     for (int i=0; i<pe_shared->sections.section_count; i++) {
          if (s->data_address<l) l=s->data_address;
          if (s->data_address+s->data_size>h) h=s->data_address+s->data_size;
          s++;
     }
/**/
	l+=pe_shared->pe32header.image_base;
	h+=pe_shared->pe32header.image_base;
     v->insertsub(new hts_analy(file, p, l, h, pe_shared->pe32header.entrypoint_address+pe_shared->pe32header.image_base));

     return v;
}

viewer_int htpeimage_int = {
	htpeimage_detect,
	htpeimage_init
};
