#ifndef __HTUNASM_H_
#define __HTUNASM_H_

#include "global.h"
#include "htdebug.h"

#include <stdarg.h>

/*
 *	CLASS ht_unasm
 */

class ht_unasm {
private:
	char ubuf[128];
     int stdopsize, stdaddrsize;
/* initme! */
     int opsize, addrsize;
     int prefix;
     int modrmv, sibv;
     int invalid;
     char *ubufp;
	unsigned char *bufp;
	int default_pick_sign;
     int vaddr;				/* current virtual address (important for relatively branching ops) */
/* new */
     unsigned char getbyte();
     unsigned short getword();
     unsigned long getdword();
     int modrm();
     int sib();
     int uprintf(char *format, ...);
     int vuprintf(char *format, va_list args);
     void uputc(char c);
	int bytesize(char c);
	void ua_ohex(char c, int extend, int defsize, int sign);
	void ua_reg_name(int which, char size);
     int ua_do_sib(int m);
	void ua_do_modrm(char c);
	void ua_floating_point(int e1);
	void ua_percent_str(char c, char **tptr);
	void ua_str(char *s);
	void size_ohex(char c, int defsize);
     void size_do_sib(int m);
	void size_do_modrm(char c);
	void size_floating_point(int e1);
     void size_percent_str(char c, char **tptr);
     void size_str(char *s);
     STUB virtual char* addr_sym_func(ADDR addr);
public:
	ht_unasm();
	ht_unasm(int seg_size);
	virtual ~ht_unasm();
/* new */
     void set_segsize(int seg_size);
     char *getstring(unsigned char *code, int maxsize, int addr, int *size);
     int getsize(unsigned char *code, int maxsize);
};

#endif /* !__HTUNASM_H_ */
