/*
 *   htcurses.h - DJGPP implementation
 */

#ifndef __HTCURSES_H__
#define __HTCURSES_H__

#define CHAR_BORDERV (unsigned char)'\xb3'
#define CHAR_BORDERH (unsigned char)'\xc4'
#define CHAR_BORDERTL (unsigned char)'\xc3'
#define CHAR_BORDERTR (unsigned char)'\xb4'
#define CHAR_BORDERTU (unsigned char)'\xc2'
#define CHAR_BORDERTD (unsigned char)'\xc1'
#define CHAR_CORNERUL (unsigned char)'\xda'
#define CHAR_CORNERLL (unsigned char)'\xc0'
#define CHAR_CORNERUR (unsigned char)'\xbf'
#define CHAR_CORNERLR (unsigned char)'\xd9'
#define CHAR_X (unsigned char)'\xb1'
#define CHAR_UP (unsigned char)'\x1e'
#define CHAR_DOWN (unsigned char)'\x1f'

#include "common.h"

#include <stdarg.h>

struct drawbufch {
	int ch;
     int c;
};

/*
 *	CLASS genericdrawbuf
 */

class genericdrawbuf {
public:
	bounds size;

	genericdrawbuf();
	virtual ~genericdrawbuf();
     virtual void fill(int x, int y, int w, int h, int c);
	        int printf(int x, int y, int c, char *format, ...);
	virtual int print(int x, int y, int c, char *text);
	virtual int lprint(int x, int y, int c, int l, char *text);
     virtual void setbounds(bounds *b);
};

/*
 *	CLASS drawbuf
 */

class drawbuf: public genericdrawbuf {
public:
     drawbufch *buf;

	drawbuf(bounds *b);
	~drawbuf();
     void fill(int x, int y, int w, int h, int c);
	int print(int x, int y, int c, char *text);
	int lprint(int x, int y, int c, int l, char *text);
     void setbounds(bounds *b);
};

class drawbuf;

class screendrawbuf: public genericdrawbuf {
protected:
     unsigned short *buf;
     int screensel;
	int cursorx, cursory;
public:
	screendrawbuf();
	~screendrawbuf();
     void fill(int x, int y, int w, int h, int c);
	int print(int x, int y, int c, char *text);
	int lprint(int x, int y, int c, int l, char *text);
     void setbounds(bounds *b);
/* new */
	void drawbuffer(drawbuf *buf, int x, int y);
     void	show();
	void getcursor(int *x, int *y);
	void hidecursor();
	void showcursor();
	void setcursor(int x, int y);
};

extern int xres, yres;

/*
 *	misc
 */

#endif /* !__HTCURSES_H__ */
