/* 
 *	The HTE Editor
 *	main.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>

#include "htapp.h"
#include "htcfg.h"
#include "htcurses.h"
#include "htdialog.h"
#include "htfile.h"
#include "htidle.h"
#include "htkeyb.h"
#include "htlayout.h"
#include "htobj.h"
#include "htinfo.h"
#include "viewers.h"

char *htcopyrights[]=
{
	ht_loadtitle,
	htanalyser_loadtitle,
     0
};

int exitht=0;

void idle()
{
	do_idle();
}

void sendkeymsg(int key)
{
	htmsg msg;
     msg.msg=htm_keypressed;
     msg.type=htmt_nothing;
     msg.data_int=key;
     app->sendmsg(&msg);
     if (msg.msg==htm_keypressed) {
		switch (msg.data_int) {
			case K_Escape:
          		exitht=1;
                    app->clearmsg(&msg);
               	break;
		}
	}
}

void copyright()
{
	char **copyrights=htcopyrights;
	while (*copyrights) {
          printf(*copyrights);
          copyrights++;
     }
     printf(htlicenseinfo);
}

void help()
{
	copyright();
     printf("Syntax: "ht_name" file\n");
     exit(1);
}

void init()
{
     htapp_init();
     htlayout_init();
}

void done()
{
     htlayout_done();
	htapp_done();
}

int main(int argc, char *argv[])
{
     if (argc<2) help();
	init();

	char **copyrights=htcopyrights;
	while (*copyrights) {
          app->logf(*copyrights);
          copyrights++;
     }

     for (int i=1; i<argc; i++) app->new_window(argv[i]);
	app->sendmsg(htm_draw, 0);
     int h0=new_timer();
	while (!exitht) {
		if (htkeypressed()) {
			do {
				sendkeymsg(htgetkey());
			} while (htkeypressed());
			app->sendmsg(htm_draw, 0);
//               rprintf(0, 0, htc_normal, "alldraw: %d", (int)get_timer_tick(h0));
          }
/*         	while (htkeypressed()) {
			if (!keyevent(htgetkey())) draw();
		}*/
          idle();
     }
     delete_timer(h0);
     done();
//     write_cfg_file(viewer, viewer_count);
}
